<?php
if( !class_exists( 'f70StocDisplay' ) ){
class f70StocDisplay {
/////////
	protected $content_str;
	
	public function __construct( $str ) {
		$this->content_str = $str;
	}
	
	function content() {
		global $post;
		
		$val_on_off = get_post_meta( $post->ID, 'f70stoc_setting_on_off', true );
		if ( $val_on_off !== 'on' ) {
			return $this->content_str;
		}
		
		$val_headers = get_post_meta( $post->ID, 'f70stoc_setting_including_headers', true );
		if ( $val_headers == 'h2' ) {
			$add_h3 = false;
		} else {
			$add_h3 = true;
		}
		
		$table_str = $this->make_table( $this->content_str, $add_h3 );
		$content = $this->touch_anchor( $this->content_str );
		$content = preg_replace( '/(<span id=\"more-.*?\"><\/span>)/', "$1\n".$table_str, $content);
		
		return $content;
	}
	
	
	function get_headings( $content ){
		$headers = array();
		
		preg_match_all('/<h[2|3].*?>(.*?)<\/h[2|3]>/', $content, $matches);
		if ( empty( $matches ) ) {
			return $headers;
		}
		$l = 1;
		foreach ( $matches[0] as $match ) {
			$array = array(
				'anchor_name' => '',
				'title_str'	=>	'',
				'head'	=>	'',
				'match_str' =>	$match,
			);
			
			if ( stristr( $match, '<h2' ) !== FALSE ) {
				$array['head'] = 2;
			} elseif ( stristr( $match, '<h3' ) !== FALSE ) {
				$array['head'] = 3;
			}
			
			if ( preg_match('/id=\"(.*?)\"/', $match, $matches_id) ) {
				$array['anchor_name'] = $matches_id[1];
			} else {
				$array['anchor_name'] = 'index' . $l;
			}
			
			$array['title_str'] = strip_tags( $match );
			
			$headers[] = $array;
			$l ++;
		}
		return $headers;
	}
	
	
	function make_table( $content, $add_h3 = true ) {
		
		$headers = $this->get_headings( $content );
		if ( empty( $headers ) ) { return; }
		
		//見出し構造を整理
		$array_h2 = array();
		$array_h3 = array();
		$x = 0;
		$p = 0;
		foreach ( $headers as $header ) {
			if ( $header['head'] == 2 ) {
				$x ++;
				$array_h2[$x] = $header;
			}
			if ( $header['head'] == 3 ) {
				$array_h3[$x][] = $header;
			}
			$p ++;
		}
		
		//目次htmlを作成
		if ( !empty( $array_h2 ) ) {
			$y = 1;
			$i = 1;
			
			$add_class = '';
			if ( $add_h3 ) {
				$add_class = ' add_h3';
			}
			
			$mokuji_str = '<div id="f70stoc" class="table-of-contents' . $add_class . '"><span class="f70toc-header">' . __( 'Table of contents', 'f70-simple-table-of-contents' ) . '</span>';
			$mokuji_str .= '<ol>';
			foreach ( $array_h2 as $h2 ) {
				$mokuji_str .= '<li><a href="#' . $h2['anchor_name'] . '">' . $h2['title_str'] . '</a>';
				$i ++;
				
				if ( !empty( $array_h3[$y] ) && $add_h3 ) {
					$h3ul = '<ol>';
					foreach ( $array_h3[$y] as $h3 ) {
						$h3ul .= '<li><a href="#' . $h3['anchor_name'] . '">' . $h3['title_str'] . '</a></li>'."\n";
						$i ++;
					}
					$h3ul .= '</ol>';
					$mokuji_str .= $h3ul;
					$h3ul = '';
				}
				$mokuji_str .= '</li>'."\n";
				$y ++;
			}
			$mokuji_str .= '</ol></div>';
		}
		return $mokuji_str;
	}
	
	
	
	function touch_anchor( $content ) {
		$headers = $this->get_headings( $content );
		if ( empty( $headers ) ) { return $content; }
		
		//アンカーを付与
		foreach ( $headers as $header ) {
			
			if ( preg_match ( '/^index/', $header['anchor_name'] ) ) {
				$replace = preg_replace('/(<h.*?)>/', "$1" . ' id="' . $header['anchor_name'] . '">', $header['match_str'] . "\n");
				$content = preg_replace( '/' . preg_quote($header['match_str'], '/') . '/', $replace, $content, 1);
			}
		}
		return $content;
		
	}


/////////
}
}